
var renderClass = "jp.ngt.rtm.render.VehiclePartsRenderer";
importPackage(Packages.org.lwjgl.opengl);
importPackage(Packages.jp.ngt.rtm.render);
importPackage(Packages.jp.ngt.ngtlib.math);
importPackage(Packages.jp.ngt.rtm)
importPackage(Packages.jp.ngt.rtm.entity.train.util);
importPackage(Packages.jp.ngt.ngtlib.io);
importPackage(Packages.jp.ngt.rtm.entity.vehicle);
importPackage(Packages.jp.ngt.ngtlib.util);
importPackage(Packages.jp.ngt.ngtlib.renderer);
//データ保存処理(グローバル関数)
var LocalData = new java.util.HashMap();

//##### オブジェクト定義 ####################
function init(par1, par2) {


    //車体
    body = renderer.registerParts(new Parts("body", "body-s", "parts", "int", "under", "window", "door"));
    lightF = renderer.registerParts(new Parts("light-F"));
    lightB = renderer.registerParts(new Parts("light-B"));

    //台車
    bogieF = renderer.registerParts(new Parts("TR230F")); //前台車枠
    wheelF1 = renderer.registerParts(new Parts("FwheelF")); //前車輪前
    wheelF2 = renderer.registerParts(new Parts("FwheelB")); //前車輪後
    bogieB = renderer.registerParts(new Parts("TR230B")); //前台車枠
    wheelB1 = renderer.registerParts(new Parts("BwheelF")); //前車輪前
    wheelB2 = renderer.registerParts(new Parts("BwheelB")); //前車輪後
    //init内で定義した変数は使い回せるので固定値などはここで設定しておくと良

    //車両設定
    bogieSet = {};
    bogieSet.bd0 = 7.0; //bogiePos前
    bogieSet.bd1 = -7.0; //bogiePos後
    bogieSet.wy0 = -0.57; //車軸Y
    bogieSet.wz1 = 8.0; //車軸1 Z
    bogieSet.wz2 = 6.0; //車軸2 Z
    bogieSet.wz3 = -6.0; //車軸3 Z
    bogieSet.wz4 = -8.0; //車軸4 Z
}


function MCVersionChecker() {
    var varsion = RTMCore.VERSION;
    if (varsion.indexOf("1.7.10") >= 0) return "1.7.10";
    else if (varsion.indexOf("2.0") >= 0) return "1.8.9";
    else if (varsion.indexOf("2.1") >= 0) return "1.9.4";
    else if (varsion.indexOf("2.2") >= 0) return "1.10.2";
    else if (varsion.indexOf("2.4") >= 0) return "1.12.2";
    else return "unknown";
}

//##### 号車取得 ####################
function isMiddleCar(entity) {//trueなら中間車、falseなら先頭車/後尾車

    //-通さない処理-
    if (entity === null) return;
    //if (renderer.currentMatId !== 3) return;//材質でも走査されるため

    var data = LocalData.get(entity);//保存された"データ群"の呼び出し
    var state = false;

    var formation = entity.getFormation();//formation型
    if (formation == null) {//formationが取得できないときの処理
        state = data.prevstate;
        if (data.prevstate == null) state = false;
    } else {
        var current = formation.getEntry(entity).entryId + 1;//この車両の号車を取得。0から数えるため+1する
        var max = formation.size();//連結してる両数を返す
        if (current == 1 || current == max) {//この車両が先頭or最後尾なら
            state = false;
        } else {//そうでない(つまり中間)なら
            state = true;
        }
    }

    data.prevstate = state;
    LocalData.put(entity, data);

    return state;
}

//##### render ####################
function render(entity, pass, par3) {
    //データ保存処理の初期化
    //Entityをキーにしてるので競合を起こさない(setData/getDataのビットシフトより確実性が高い)
    //必ず一番最初に実行されるように書く
    var data = LocalData.get(entity) || {};
    LocalData.put(entity, data);


    var Middle = isMiddleCar(entity);
    var varsion = MCVersionChecker();

    //数値設定
    var doorMove = 0.64, //ドア開閉距離(m)
        pantaDistance = 6.3, //パンタ中心の前後位置(m)
        pantaType = "W51"; //パンタ高(Normal:標準-格納 / W51:W51-格納 / Compatible:標準-W51)

    GL11.glPushMatrix();


    //通常描画
    if (pass == 0) {
        body.render(renderer);
        render_light(entity, Middle, pass);
        render_bogie(entity);
    }

    //半透明描画
    if (pass == 1) {
        if (varsion == "1.12.2") { //RTM1でない(RTM2であるとき)
            GLHelper.setBrightness(entity ? entity.func_70070_b() : 0); //明るさ再設定
        }
        alpha.render(renderer);
    }

    //発光部描画
    if (pass > 1) {
        body.render(renderer);
        render_light(entity, Middle, pass);
    }
    GL11.glPopMatrix();

}

//##### render_ライト ####################
function render_light(entity, Middle, pass) {

    var varsion = MCVersionChecker();
    var lightMove = 0;

    if (entity != null) {
        if (varsion == "1.7.10" || varsion == "1.8.9" || varsion == "1.9.4") {
            lightMove = entity.getTrainStateData(0);
        } else {
            lightMove = entity.getVehicleState(TrainState.getStateType(0));
        }

    }



    GL11.glPushMatrix();
    if (Middle == false) {



        if (lightMove == 0) {
            GL11.glPushMatrix();
            lightF.render(renderer);
            GL11.glPopMatrix();
        } else {
            GL11.glPushMatrix();
            lightB.render(renderer);
            GL11.glPopMatrix();
        }

    } else {


        if (pass == 0) {
            GL11.glPushMatrix();
            lightB.render(renderer);
            GL11.glPopMatrix();
        }

    }
    GL11.glPopMatrix();
}

//##### render_台車 hi03 Bogiekitより ####################
function render_bogie(entity) {

    //初期化
    var f0 = renderer.getWheelRotationR(entity),
        bogieFYaw = 0.0,
        bogieBYaw = 0.0,
        bogieFPitch = 0.0,
        bogieBPitch = 0.0;


    //取得
    if (entity != null && entity.getBogie(0) != null && entity.getBogie(1) != null) {
        var bodyYaw = entity.field_70177_z;

        //前台車ヨーローカル角
        var i = entity.getBogie(0).field_70177_z - bodyYaw;
        if (i > 180) {
            bogieFYaw = i - 360;
        } else if (i < -180) {
            bogieFYaw = i + 360;
        } else {
            bogieFYaw = i;
        }
        //後台車ヨーローカル角
        var i = entity.getBogie(1).field_70177_z - bodyYaw - 180;
        if (i > 180) {
            bogieBYaw = i - 360;
        } else if (i < -180) {
            bogieBYaw = i + 360;
        } else {
            bogieBYaw = i;
        }

        //ピッチローカル角
        var bodyPitch = entity.field_70125_A;
        bogieFPitch = entity.getBogie(0).field_70125_A * -1 + bodyPitch;
        bogieBPitch = entity.getBogie(1).field_70125_A + bodyPitch;

    }


    //前台車
    GL11.glPushMatrix();
    renderer.rotate(bogieFYaw, 'Y', 0.0, 0.0, bogieSet["bd0"]);
    renderer.rotate(bogieFPitch, 'X', 0.0, 0.0, bogieSet["bd0"]);
    bogieF.render(renderer);
    GL11.glPushMatrix();
    renderer.rotate(f0, 'X', 0.0, bogieSet["wy0"], bogieSet["wz1"]);
    wheelF1.render(renderer);
    GL11.glPopMatrix();
    GL11.glPushMatrix();
    renderer.rotate(f0, 'X', 0.0, bogieSet["wy0"], bogieSet["wz2"]);
    wheelF2.render(renderer);
    GL11.glPopMatrix();
    GL11.glPopMatrix();

    //後台車
    GL11.glPushMatrix();
    renderer.rotate(bogieBYaw, 'Y', 0.0, 0.0, -bogieSet["bd0"]);
    renderer.rotate(bogieBPitch, 'X', 0.0, 0.0, -bogieSet["bd0"]);
    bogieB.render(renderer);
    GL11.glPushMatrix();
    renderer.rotate(f0, 'X', 0.0, bogieSet["wy0"], bogieSet["wz3"]);
    wheelB1.render(renderer);
    GL11.glPopMatrix();
    GL11.glPushMatrix();
    renderer.rotate(f0, 'X', 0.0, bogieSet["wy0"], bogieSet["wz4"]);
    wheelB2.render(renderer);
    GL11.glPopMatrix();
    GL11.glPopMatrix();
}

